---
apiVersion: "apps/v1"
kind: "Deployment"
metadata:
  name: "{{ $.Release.Name }}"
spec:
  replicas: 1
  revisionHistoryLimit: 1
  selector:
    matchLabels:
      app.kubernetes.io/name: "dns"
      app.kubernetes.io/instance: "{{ $.Release.Name }}"
  template:
    metadata:
      labels:
        app.kubernetes.io/name: "dns"
        app.kubernetes.io/instance: "{{ $.Release.Name }}"
    spec:
      affinity:
        nodeAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 1
              preference:
                matchExpressions:
                  - key: "node-role.kubernetes.io/control-plane"
                    operator: "Exists"
      containers:
        - name: "server"
          image: "coredns/coredns:1.10.1"
          command:
            - "/coredns"
            - "-conf"
            - "/coredns.d/Corefile"
          resources:
            requests:
              memory: "16Mi"
              cpu: "50m"
            limits:
              memory: "32Mi"
              cpu: "100m"
          volumeMounts:
            - name: "configmap"
              mountPath: "/coredns.d/"
      volumes:
        - name: "configmap"
          configMap:
            name: "{{ $.Release.Name }}"
      tolerations:
        - key: "node-role.kubernetes.io/control-plane"
          operator: "Exists"
          effect: "NoSchedule"
